#pragma semicolon 1

public Plugin:myinfo = 
{
	name	= "Map Config",
	author	= "wS",
	version	= "1.2.5",
	url		= "http://world-source.ru/"
};

#define szf(%0)				%0, sizeof(%0)

#define TIMER_NOTSTARTED	0
#define TIMER_STARTED		1
#define TIMER_FINISHED		2

new Handle:mc_restart_map, X = TIMER_NOTSTARTED;
new Handle:mc_timer;

#define CMD_SIZE			512
new Handle:mc_cmd_delay_trie;
new mc_cmd_delay_trie_key;

public OnPluginStart()
{
	mc_cmd_delay_trie = CreateTrie();
	
	CreateDirectory("cfg/map_config", 511);
	CreateDirectory("cfg/map_config/settings", 511);
	
	mc_restart_map = CreateConVar("mc_restart_map", "0", "Перезагрузить карту через 'x' секунд после включения сервера (0 = откл)");
	mc_timer = CreateConVar("mc_timer", "0", "Подгружать конфиги карты через 'x' секунд после server.cfg (0 = без задержки)");
	AutoExecConfig(true, "settings", "map_config/settings");
	
	RegServerCmd("mc_cmd_delay", mc_cmd_delay, "mc_cmd_delay <cmd> <delay>");
}

public OnMapEnd()
{
	ClearTrie(mc_cmd_delay_trie);
	mc_cmd_delay_trie_key = 0;
}

public OnConfigsExecuted()
{
	new Float:fSec;
	
	if (X == TIMER_NOTSTARTED) // рестарт карты
	{
		if ((fSec = GetConVarFloat(mc_restart_map)) > 0.0)
		{
			X = TIMER_STARTED;
			CreateTimer(fSec, mc_restart_map_TIMER);
			return;
		}
		X = TIMER_FINISHED;
	}
	
	// подгрузка конфигов
	if ((fSec = GetConVarFloat(mc_timer)) > 0.0) {
		CreateTimer(fSec, exec_try_TIMER, _, TIMER_FLAG_NO_MAPCHANGE);
	}
	else {
		exec_try();
	}
}

GetMap(String:sMap[], size)
{
	GetCurrentMap(sMap, size);
	ReplaceString(sMap, size, "\\", "/");
	new index = FindCharInString(sMap, '/', true);
	if (index > -1) {
		strcopy(sMap, size, sMap[index + 1]);
	}
}

exec_try()
{
	decl String:sMap[256];
	GetMap(szf(sMap));
	
	//new bool:bNeedExecute = false;

	new index = FindCharInString(sMap, '_', false);
	if (index > 0)
	{
		sMap[index] = 0;
		if (exec_func(sMap)) {
			//bNeedExecute = true;
		}
		sMap[index] = '_';
	}
	
	/*if (exec_func(sMap) || bNeedExecute) {
		ServerExecute();
	}*/
	exec_func(sMap);
}

bool:exec_func(const String:sMap[])
{
	decl String:sInfo[PLATFORM_MAX_PATH];
	FormatEx(szf(sInfo), "cfg/map_config/%s.cfg", sMap);
	if (FileExists(sInfo))
	{
		ServerCommand("exec \"%s\"", sInfo[4]);
		return true;
	}
	return false;
}

public Action:mc_restart_map_TIMER(Handle:timer)
{
	X = TIMER_FINISHED;
	decl String:sMap[256];
	GetMap(szf(sMap));
	ServerCommand("changelevel \"%s\"", sMap);
	//ServerExecute();
	return Plugin_Stop;
}

public Action:exec_try_TIMER(Handle:timer)
{
	exec_try();
	return Plugin_Stop;
}

//

public Action:mc_cmd_delay(args) {
	if (args == 2) {
		decl String:s[CMD_SIZE];
		if (GetCmdArg(2, szf(s))) {
			decl String:k[12];
			new Float:fDelay = StringToFloat(s);
			if (fDelay > 0.0
				&& GetCmdArg(1, szf(s))
				&& TrimString(s)
				&& IntToString(++mc_cmd_delay_trie_key, szf(k))
				&& SetTrieString(mc_cmd_delay_trie, k, s, true))
			{
				CreateTimer(fDelay, mc_cmd_delay_, mc_cmd_delay_trie_key, TIMER_FLAG_NO_MAPCHANGE);
			}
		}
	}
	return Plugin_Handled;
}

public Action:mc_cmd_delay_(Handle:timer, any:k_num)
{
	decl String:k[12], String:s[CMD_SIZE];
	if (IntToString(k_num, szf(k)) && GetTrieString(mc_cmd_delay_trie, k, szf(s)))
	{
		RemoveFromTrie(mc_cmd_delay_trie, k);
		ServerCommand(s);
	}
	return Plugin_Stop;
}